\subsection{Power consumption}
Based on the interviews the following not complete Table~\ref{tab:pwr_consumption}
can be produced.

\begin{table*}  
  \begin{center}
    \caption{Total power and cooling budget with maximum, average and idle power draws (units are in MW)}
    \label{tab:pwr_consumption}
    \begin{tabular}{|c||c|c|c|c|c|}
      \hline
      \textbf{Center} & \textbf{Power Budget} & \textbf{Cooling Budget} & \textbf{Maximum draw} & \textbf{Average draw} & \textbf{Idle draw} \\
      \hline
      \hline
      \textbf{RIKEN} & 23 & 36 & 15 & 12 & 10 \\
      \textbf{Tokyo} & 2 & 2 & 1.4 & 0.8 & 0.55 \\
      \textbf{CEA} & 10 & 7.5 & & 5 &  \\	
      \textbf{KAUST} & 3.6 & 2.9 & 3 & 2 & 0.55 \\
      \textbf{LRZ 1} & 10 & 10 & 2.9 & 2.2 & 0.7 \\
      \textbf{LRZ 2} & 10 & 10 & 1.5 & 1.2 & 0.4 \\
      \textbf{STFC} & 4.5 & 2 & 1 & & \\		
      \textbf{Trinity} & 19.2 &	27 & 8.4 & & 2.4 \\
      \textbf{Cineca} &	6 & & & & \\
      \textbf{JCAHPC} &	8 & 4.2 & 3.2 & 2.4 & \\	
      \hline
    \end{tabular}
  \end{center}
  \vspace{-1mm}
\end{table*}

From this Table we can build the graph shown in Figure~\ref{fig:pwr_consumption}
that illustrates what is percentage of total power budget for each of three
reported power draws, namely maximum, average and idle.

\begin{figure}
  \begin{center}
    \includegraphics[width=0.85\linewidth]{images/pwr_consumption.pdf}
    \caption{Maximum, average and idle power consumption as percentage of total power budget}
    \label{fig:pwr_consumption}
  \end{center}
\end{figure}

From Figure~\ref{fig:pwr_consumption} it immediately stands out
that out of all centers LRZ is the only one that has almost the same
maximum and average power draw.  This is due to the scheduler they are
using.  They are using \texttt{LoadLeverer}\cite{loadLeveler} for scheduling.  This
scheduler characterise each application before it is run and then when
application with similar characteristics it is run the scheduler picks
up the optimal frequency that reduces the total power consumption.
Therefore, each time the application is ran it ends up using all of
the available power.  As a result this further minimises the total
amount of energy used for running applications on LRZ machine.  This
has led LRZ to be the centre that uses the least amount of power out
of total budget.  But, it is not only LRZ that has
\textit{over-provisioned} their data center.  Almost all other centers
(maybe apart from KAUST) are not fully utilising available power
budget that they have on site.  Therefore, there are some significant
opportunities to use available power budget to increase performance of
the systems.

\subsubsection{Idleness}

Nowadays, power efficiency is measured when system is at maximum load,
but \textbf{most} of the systems operate far away from peak activity.
Mostly the peak power measurement is observed with HPL benchmark but
contemporary applications do not anymore correlate well with behaviour
of HPL.  Thus, we need to look at building \textit{ideal} idle system.

The ideal idle system is one that\cite{barroso2007case}:

\begin{enumerate}
\item consumes \textbf{NO} power when it is idle, and
\item power increases proportionally with increasing activity.
\end{enumerate}

\begin{figure}
  \begin{center}
    \includegraphics[width=0.85\linewidth]{images/average_pwr.pdf}
    \caption{Average power consumption as percentage of maximum power consumption}
    \label{fig:average_pwr}
  \end{center}
\end{figure}

Figure~\ref{fig:average_pwr} shows percentage of average power draw to
maximum power draw for each center.  What immediately jumps out from
this Figure is that Tokyo Tech is using slightly above 50\% of maximum
power draw.  The reason for this is because this is the only center
that actually powers down idle nodes and as a result when applications
(that are on average using far less power then benchmark like HPL) are
running idle nodes are consuming no power when idle.  Apart from LRZ
and Tokyo Tech all other centers could use power capping to keep their
systems consuming too much power.  KAUST runs 70\% of their nodes
under power cap, Trinity is using Cray's CAPMC power capping, RIKEN
automatically kills when power limit exceeds and JCAHPC has power caps
for groups of nodes.

\subsection{Improvements on resource managers}
LRZ is using IBM LoadLeveler. LRZ procured energy saving
functionality for LoadLeveler because energy consumption, power
requirements, CO2 emission and associated costs are becoming a major
concern for the wider public and for their funding agency. IBM implemented for LRZ energy tags
that they can associate with jobs. These energy tags are then used
to decide which frequency should be used to run the job to save
energy under a maximum performance degradation contraint.

TokyoTech is using the PBS Professional Scheduler on their TSUBAME2.5 system.
Initially, the scheduler was utilized out-of-box but together with
NEC they have designed and developed several software components that
work outside of PBS that implement \textit{system-level power
capping} (system power fits within given power bound) and an
\textit{idle node energy saving} (shutting down idle nodes) capability.

JCAHPC is using a proprietary solution developed
by Fujitsu for their batch scheduling system. When procuring the system their main requirements were for
the solution to be capable of implementing power capping and to track the
power consumption of each job. These capabilities were developed by
Fujitsu and made available in their commercial product, with no site-specific
modifications required as JCAHPC does not have permissions
to make changes to Fujitsu's job scheduler. In addition to JCAHPC,
Riken is also using Fujitsu's job scheduler on their system. They are
using the power capping features of Fujitsu's job scheduler to
automatically stop jobs once excess power use is detected. Together
with Fujitsu Riken is planning to extend the job scheduler in the future
to support job power estimation and energy aware scheduling based on
this information. 

CINECA is using the PBS Professional Scheduler and together with the University of Bologna,
they have written plugins to the scheduler that periodically
monitor performance counters and power consumption using the MulTitherMon
scalable monitoring framework.  A linear optimization method is used to
implement custom scheduling logic for increasing resource utilization.
The concepts and capabilities implemented by these plugins are
applicable to open-source scheduler solutions such as SLURM, and this is
a subject of current work.

Trinity initially used Adaptive Computing's MOAB/Torque product for
resource management.  As part of the Trinity project, advanced power
management capabilities including system and job-level power band control,
power ramp rate management, and power usage forcasting were implemented by
Adaptive Computing.  These capabilities are now available in Adaptive's
commercial product.

Kaust is using the dynamic power management capability of the open-source SLURM
scheduler.  This solution interfaces with Cray's CAPMC infrastructure to measure
and control the system and job-level power usage.
No other changes were made to the SLURM scheduler. Like Kaust, CEA is also using the
SLURM scheduler. But, in contrast to Kaust, CEA has developed an in-house
developed \textit{meta-scheduler} that is in charge of generating the
workload according to their scheduling policies. This meta-scheduler
is portable to other schedulers such as LSF and MOAB. Additionally,
a web interface provides access to the energy usage of each job and total
system power.  The meta-scheduler does not currently use this information
to make energy-aware decisions or to implement power capping.

STFC is using the IBM Platform LSF
scheduler. On one of their heterogeneous platforms (Intel Ivy Bridge +
Intel Xeon Phi) they have implemented a capability for LSF where
based on the amount of time that a node has been idle, they set the node's
S-state so it consumes less energy.

This is summarised in Table~\ref{tab:pwr_schedulers}.

\begin{table*}
  \begin{center}
    \caption{Changes applied to generic resource management solutions at each site}
    \label{tab:pwr_schedulers}
    \begin{tabular}{|c||c|c|c|p{4.5cm}|p{4cm}|}
      \hline
      \textbf{Center} & \textbf{Vendor} & \textbf{Product} & \textbf{Type} & \textbf{Changes} & \textbf{Level of deployment} \\
      \hline
      \hline
      \textbf{RIKEN} & Fujitsu & NA & Proprietary & power estimation and EAS & Partial (only power capping) \\
      \textbf{Tokyo} & Altair & PBSPro & Proprietary & power capping and node shutdown & Partial (only power capping)\\
      \textbf{CEA} & Bull & SLURM & Open-source & meta-scheduler & Partial (only power monitoring) \\ 
      \textbf{KAUST} & Bull & SLURM & Open-source &  & None \\
      \textbf{LRZ} & IBM & LoadLeverer & Proprietary & energy tags to pick running frequency & Full (tested and integrated)  \\
      \textbf{STFC} & IBM & LSF & Proprietary & change of node P-states & Full (tested and integrated) \\
      \textbf{Trinity} & Altair & PBSPro & Proprietary & power capping and power estimation & None \\
      \textbf{Cineca} &	Altair & PBSPro & Proprietary & power monitoring & Partial (only power monitoring) \\
      \textbf{JCAHPC} &	Fujitsu & NA & Proprietary &  & None\\
      \hline
    \end{tabular}
  \end{center}
\end{table*}

The last column of Table~\ref{tab:pwr_schedulers} shows the level of
deployment of energy and power aware job scheduling and resource
management solutions at each site. Only LRZ and STFC have applied systematic control of the voltage and frequency scaling in production, with LRZ being the first the first. The centers from Japan focused mostly on power capping implemented either automatic or manual. The rest of the sites are only
either capable of measuring, predicting or estimating power consumption at
different granularity with only some initial tests on energy efficiency optimizzation. 


%%  LocalWords:  Center RIKEN CEA KAUST LRZ STFC Cineca JCAHPC HPL
%%  LocalWords:  centers LoadLeverer center CAPMC LoadLeveler TSUBAME
%%  LocalWords:  supercomputing TokyoTech NEC Riken MulTitherMon Moab
%%  LocalWords:  scalable SLURM Tourqe Kaust LSF Xeon EAS PBSPro
